
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>控制动态servlet图形处理(2) / iVAN</title>

    <meta name="description" content="控制动态servlet图形处理(2) servlet|动态|控制|图形 编写定制 JSP 标记 既然明白了 Web 服务器是如何处理 JSP 页面请求的,那么让我们研究一下如何实现定制 JSP 标记.注:JSP 标记既来自标准库(如 Java Standard Template Library,JSTL),也来自您自己编写的库(也称为定制标记).通常,定制标记处理特殊的问题领域.对本文而言,我们在处理如何管理图像.目前,Java 2 Extended Edition(J2EE)V1.2 和 V1.3 使用 JSP 规范 V1.2.在">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">控制动态servlet图形处理(2)</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>servlet|动态|控制|图形</p>
<p>编写定制 JSP 标记</p>
<p>既然明白了 Web 服务器是如何处理 JSP 页面请求的，那么让我们研究一下如何实现定制 JSP 标记。注：JSP 标记既来自标准库（如 Java Standard Template Library，JSTL），也来自您自己编写的库（也称为定制标记）。通常，定制标记处理特殊的问题领域。对本文而言，我们在处理如何管理图像。目前，Java 2 Extended Edition（J2EE）V1.2 和 V1.3 使用 JSP 规范 V1.2。在写作本文的时候，Sun 已经发布了 JSP 规范 V2.0。这个新规范并未对实现定制标记的方法进行重大更改。</p>
<p>通过 taglib 伪指令，可以将标准和定制标记库导入 JSP 页面，如下所示：</p>
<pre>&lt;%@ taglib uri='imagesizer.tld' prefix='util' %&gt;</pre>
<p>这个伪指令指定了标记库描述符文件的位置，这里指定的是 imagesizer.tld，还指定了在页面中使用它时的前缀，这里指定的是 util。如前面的标记示例所示，将标记与其前缀及其名称一起使用：</p>
<pre>&lt;util:imagesizer src="http://www.163design.net/j/f/images/LazyDog.jpg"/&gt;</pre>
<p>标记库描述符告诉 Web 容器哪些标记是可用的，以及它们如何发挥作用。清单 1 显示了这样一个示例。文件使用了 XML 格式，并且易于读取，而应用程序开发平台 — 如 IBM WebSphere Studio Application Developer（Application Developer）可以帮助您填充字段，并且验证文件。最重要的信息是 tag 元素：它定义了定制 JSP 标记的名称和实现标记的 Java 类。它还显示了标记接受的任何属性和主体内容。</p>
<p>清单 1. 标记库描述符（Tag Library Descriptor，TLD）摘录</p>
<pre>&lt;taglib &gt;  &lt;tlibversion&gt; 1.0 &lt;/tlibversion&gt;  &lt;jspversion&gt; 1.1 &lt;/jspversion&gt;  &lt;tag&gt;    &lt;name&gt;imagesizer&lt;/name&gt;    &lt;tagclass&gt;tags.ImageSizerTag&lt;/tagclass&gt;    &lt;bodycontent&gt;empty&lt;/bodycontent&gt;    &lt;attribute&gt;      &lt;name&gt;src&lt;/name&gt;      &lt;required&gt;required&lt;/required&gt;    &lt;/attribute&gt;    &lt;attribute&gt;      &lt;name&gt;alt&lt;/name&gt;    &lt;/attribute&gt;    &lt;attribute&gt;      &lt;name&gt;quality&lt;/name&gt;    &lt;/attribute&gt;  &lt;/tag&gt;&lt;/taglib&gt;</pre>
<p>在这个示例中，tag 有三个属性，其中只有 src 属性是必需的。可选的 alt 属性模拟 HTML 的 img alt 属性。作为练习，您可以扩展该 JSP 标记以包含其它可选的 img 属性。（大约有 12 种这些属性。）最后，实现提供了一个可选的 quality 属性，以使页面编写人员可以控制已重新调整大小的图像的颗粒度和大小。 <br />编写定制 JSP 标记的下一步是实现标记的 Java 代码。在本文中，标记 imagesizer 是在 tags.ImageSizerTag Java 类中实现的。大多数 J2EE 定制标记支持都位于 javax.servlet.jsp.tagext 包中。imagesizer 类继承了标准的 TagSupport，后者实现不带主体的标记。TagSupport 的子代类是 BodyTagSupport，它也实现标记，并且带有主体。这两个类际迪至?Tag 接口，其中，当第一次读取标记以及当 Web 容器完全读取标记后再次读取标记时，会调用 doStartTag 和 doEndTag 方法。ImageSizer 标记只实现了 doEndTag，因为一旦所有属性信息都可用时，它需要起作用。</p>
<p>在 TagSupport 类中，PageContext 类提供了对有关 JSP 页面的重要信息的访问。例如，PageContext 提供了对 HttpRequest 和 HttpResponse 对象的访问。这些对象对于读取表单值和写响应是至关重要的。如果您希望跟踪用户的首选项，并且将表单值从一个页面传递到另一个页面，该请求还提供了对 HttpSession 的访问。PageContext 还提供了对 ServletContext 的访问，后者有助于您查找 servlet 的路径、名称和其它信息。在 ImageSizer 代码中（如清单 2 所示），有许多对 PageContext 对象及其提供信息的引用。图 3 显示了这些类的关系。就象任何标准类图一样，实心框代表类，而虚线框代表接口。用从派生的类或接口到其父类或接口的一条线来表示继承。</p>
<p>清单 2. ImageSizerTag doEndTag 实现</p>
<pre>// Implement the tag once the complete tag has been read.public int doEndTag() throws JspException {  // Move request data to session.  int outputSize = 0;  String sizeVal = request.getParameter( REQUESTSIZEKEY );  if ( sizeVal != null ) {    session.setAttribute( REQUESTSIZEKEY, sizeVal );    sizeVal = (String) session.getAttribute( REQUESTSIZEKEY );    if ( sizeVal != null ) {      outputSize = Integer.parseInt( sizeVal );    }  }  // Get specified image locally.  String contextPath = getContextPath( request );  Image image = Toolkit.getDefaultToolkit().getImage(contextPath + src );  ImageSizer.waitForImage( image );  int imageWidth = image.getWidth( null );  int imageHeight = image.getHeight( null );  if (( imageWidth &gt; 0 ) &amp;&amp; ( imageHeight &gt; 0 )) {    if (( outputSize &gt; 0 ) &amp;&amp; ( outputSize != imageWidth )) {      // Convert image to new size.      Image outputImage = ImageSizer.setSize( image, outputSize, -1 );      ImageSizer.waitForImage( outputImage );      int outputWidth = outputImage.getWidth( null );      int outputHeight = outputImage.getHeight( null );      if ( outputWidth &gt; 0 &amp;&amp; outputHeight &gt; 0 ) {        // Change image file name to xxxx.size.jpg        String originalSrc = src;        int lastDot = src.lastIndexOf( '.' );        if ( lastDot &gt; -1 ) {          src = src.substring( 0, lastDot + 1 );        }        setSrc( src + outputSize + ".jpg" );        // Write new size image to JPEG file.        File file = new File( contextPath + src );        if ( !file.exists() ) {          out.println( "" );          FileOutputStream fos = new FileOutputStream( contextPath + src );          ImageSizer.encodeJPEG( fos, outputImage, quality );          fos.close( ) ;        }        imageWidth = outputWidth;        imageHeight = outputHeight;      }    } // if outputSize  } // if image found  // Produce output tag.  out.print( "&lt;img src=\"" + src + "\"" );  // Add alt text, if any  if ((alt != null ) &amp;&amp; ( alt.length() &gt; 0 )) {    out.print( " alt=\"" + alt + "\"" );  }  // Add proper width, height.  out.print( " width=\"" + imageWidth + "\" height=\"" +    imageHeight + "\"" );  out.println( "&gt;" );  return EVAL_PAGE;} // doEndTag</pre>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gzLm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vMjAwNzI4MjMyOTQ4NDgxLmdpZg==.jpg"><br /> </p>
<p>图 3. 重要的 javax.servlet.jsp.tagext 类<br />清单 2 显示了 ImageSizerTag 类的 doEndTag 方法。这几乎是实现定制 JSP 标记所需的全部 Java 代码。它是一大段代码，但是它将有助于您的理解，以便全面地了解该方法。首先，任何 HTTP 请求参数都保存在 HTTP 会话中。该请求带有一个属性，如对于图像大小的用户首选项，并将其保存在会话中，以便它可以跟随用户从一个页面到另一个页面。要扩充该标记的功能，可以扩展它，使之可将用户首选项保存在 cookie 中，这样用户下一次访问站点时就可使用其首选项。</p>
<p>下一步是装入缺省图像，JSP 页面使用它来作为基图，所有其它图像都根据基图来调整大小。这里，java.awt.Toolkit 请求图像，图像是用 ImageSizer.waitForImage 装入的，并对其进行了检查，以了解其是否进行了正确的缩放。需要进行装入暂停，因为 Java 图像是异步装入的，当请求它们时并非始终完全可用。在本示例中，ImageSizer 辅助类执行整个图像处理操作，下一节将对此做进一步介绍。如果宽和高匹配，则无须重新调整图像大小，并将跳过 if 这一大块代码，而且使用图像名称和当前大小编写 HTML 图像标记。这就是 JSP 实现模拟 HTML 图像标记所需做的全部工作。</p>
<p>如果用户请求新的图像大小，那么 ImageSizer 辅助类会重新调整图像的大小。使用文件大小给图像文件指定新的名称，文件是 JPEG 编码的，并写到文件系统。接着，将在 HTML 图像标记输出中使用刚刚重新调整大小的文件。该标记的备用实现可能会将文件保存为 GIF 或 PNG 格式，或者甚至会通过内存来提供图像以节省磁盘空间。但是，清单 2 将重新调整大小的文件高速缓存到了磁盘，以备将来使用。因此，第一次重新调整大小时需要花费一些服务器处理时间，但是随后对图像大小进行请求时根本不需要处理。该示例的扩展可能会检查可用的磁盘空间，以便于帮助平衡有限的文件空间与您希望提供给客户机的即时信息之间的折衷。</p>
<p>调整图像大小<br />前一节研究了编写定制 JSP 标记的步骤。ImageSizerTag 类会自动重新调整图像的大小以匹配用户的首选项。这一节提供了有关您可以如何使用 ImageSizer 类来重新调整图像大小并将其保存为 JPEG 文件的更多详细信息。利用 java.awt.Image 类中的 getScaledInstance 方法，很容易在 Java 代码中重新调整图像的大小。利用新的宽和高调用这个方法，或者为某个参数提供一个值 -1 以保持纵横比，您可以得到新的重新调整过大小的图像。但是，就象任何 Java 图像一样，该图像并不是立即可用的，因此您必须使用 java.awt.MediaTracker 以等待图像完全装入。ImageSizer 的 waitForImage 方法封装了该代码。</p>
<p>在该示例中，最难的设计点在于决定如何保存图像。用 Java 编程编码和保存图像有很多选择，所有选择都有不同的权衡。</p>
<p>com.sun.image.codec。该包在 Java 2 SDK 1.2 和 1.3 实现中是可用的，但它在私有（private）包中，在将来的 Java 2 版本中这可能会发生变化。该包只限于 JPEG 编码。</p>
<p>Java Image I/O API。在 Java 2 SDK 1.4 中，该包是公共的和标准的。但是，在撰写本文时，还没有使用 SDK 1.4 的 J2EE 版本。该包提供了良好的图像操作功能和编码选项。</p>
<p>Java 高级映象 API（Java Advanced Imaging API）。这个 API 是一个标准扩展，但是使用它需要安装包 — 您的 Web 管理员可能不支持该工作。</p>
<p>ACME GIF 编码器（ACME GIF Encoder）。该软件及许多其它第三方图像包很有用，您可以将它们合并在示例代码中，但是有个费用和可维护性的问题。同其它选择不同，该软件不是免费的，并且不完全支持 GIF 标准。</p>
<p>对于清单 3，我们使用 com.sun.image.codec 包，因为它在所有 J2EE 1.2 和 1.3 Web 服务器容器（如 IBM WebSphere 和 Apache Tomcat）中都可用。编码器很简单，并且是 100％ 纯 Java 代码，但是它们是 com.sun 包中的。但是，从长远考虑，Java Image I/O 包可能是发展的方向。在图像转换特性以及保存为多种文件格式的能力方面，它比较强大。直到 Java 2 V1.4 时 Java Image I/O 包才会成为标准。</p>
<p>既然已经决定了使用哪个图像处理包，那么保存 JPEG 文件的代码就相当简单了。ImageSizer 的 encodeJPEG 方法封装了这个过程：</p>
<p>java.awt.image.BufferedImage 对象，这是一个增强的 Java Image 子代，是从重新调整过大小的输出图像创建的。注释在代码中标明了一个位置，可以在这里扩展示例以将徽标、水印、时间戳记或版权信息添加到图像。</p>
<p>在将 Image 转换为 BufferedImage 之后，在输出流上创建一个 JPEGImageEncoder 对象。输出编码质量的范围从 0.0（最差）到 1.0（最佳）。缺省值是 0.75，但 0.95 将生成较大的文件大小，它带有更详细的图像。作为该示例的扩展，您可以考虑由图像大小来决定质量 — 较小的图像需要较高的质量设置，而较大的图像需要较低的设置。</p>
<p>将图像编码到输出流，并对该流进行刷新以确保所有信息都显示在图像文件中。</p>
<p>清单 3. ImageSizer encodeJPEG 实现</p>
<pre>// Encodes the given image at the given// quality to the output stream.public static void encodeJPEG  ( OutputStream outputStream,  Image outputImage, float outputQuality )  throws java.io.IOException {  // Get a buffered image from the image.  BufferedImage bi = new BufferedImage    ( outputWidth, outputHeight,      BufferedImage.TYPE_INT_RGB );  Graphics2D biContext =    bi.createGraphics( );  biContext.drawImage    ( outputImage, 0, 0, null );  // Additional drawing code, such as  // watermarks or logos can be placed here.  // com.sun.image.codec.jpeg package  // is included in Sun and IBM sdk 1.3.  JPEGImageEncoder encoder =    JPEGCodec.createJPEGEncoder    ( outputStream );  // The default quality is 0.75.  JPEGEncodeParam jep =    JPEGCodec.getDefaultJPEGEncodeParam    ( bi );  jep.setQuality( outputQuality, true );  encoder.encode( bi, jep );  outputStream.flush();} // encodeImage</pre>
<p>那就是重新调整图像大小及保存图像所需的全部。</p>
<p>打包并部署到 WebSphere 或 Tomcat 上</p>
<p>本节将阐述如何打包 ImageSizer JSP 标记并将其部署到 Application Server V4.0 或 Apache Tomcat V4.0 上。图 4 显示了 Application Developer 的抓屏。左上栏的 Navigator 窗格（windowpane）显示了 Web 应用程序的目录结构，以及必须如何根据 J2EE 规范打包定制 JSP 标记。由于 J2EE 规范的需要，因此该目录结构对于所有 Web 应用程序都是公共的。一旦归档了该结构，则它将成为 Web 归档（WAR）文件，并且可以方便地将其传送给 WebSphere、Tomcat 或任何其它兼容的 Web 容器。良好的开发环境（如 Application Developer）有助于开发人员遵循这些规范，并生成有效的应用程序。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gzLm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vMjAwNzI4MjMyOTQ5NTMwLmpwZw==.jpg"><br /> </p>
<p>图 4. 在 WebSphere Studio Application Developer 中打包 ImageSizer<br />在ImageSizer项目下，有一个源代码目录；开发人员可以选择是否在最终的WAR文件中包含该目录。webApplication 目录包含实际的程序代码。示例项目包含名为 PickASize.jsp 的测试 JSP 页面及称为 LazyDog.jpg 的巨大的测试图像。通常，ImageSizer 定制标记的库版本并不包含这些。标记的实现位于 WEB-INF 目录中。Java 类都位于 WEB-INF/classes 中，而标记库描述符（Tag Library Descriptor）文件位于 WEB-INF/tlds 中。这些是所有 Web 应用程序的标准目录布局。该树中的其它文件有助于设置服务器选项，但却并非 WAR 文件强制需要的。使用 Application Developer 或 Java SDK 以创建该应用程序的 WAR 文件。</p>
<p>要将 Web 应用程序部署在 Web Application Server（如 Tomcat）上，则将文件放在 ROOT/webapps 目录中，并且让服务器将 WAR 文件展开为目录结构。对于 Application Server，您可以使用 Administrators Console 中的 Web Application 向导来安装应用程序。部署完毕，可通过访问 http://yourhostname:port/ImageSizer/PickASize.jsp 运行 JSP 页面。</p>
<p>结束语<br />现在您已经创建了自动管理图像缩放的JSP定制标记。定制标记为您省去了重新调整图像大小的工作，还使用户在访问您的网站时可以指定自己的首选项。可以很方便地扩充该示例标记以执行各种图像操作：版权文本、时间戳记、徽标或水印。通过将代码部署到 Application Server 或 Apache Tomcat，并且编写一些基于图像的 JSP 页面或使用给定的示例，您可以试验代码。希望本文为您提供了“取出即可用”的 JSP 标记，还提供了能使您进一步扩展功能以满足您需要的代码。愿您看图愉快！</p>
<p>以上是小编为您精心准备的的内容，在的博客、问答、公众号、人物、课程等栏目也有的相关内容，欢迎继续使用右上角搜索按钮进行搜索java<br />
                    ，                图像<br />
                    ，                文件<br />
                    ，                java类的动态装入<br />
                    ，                标记<br />
                    ，                imagesize<br />
                    ，                大小<br />
                    ，                图像编码 最佳匹配块<br />
                    ，                jsp img 流<br />
                                    示例<br />
                                    动态代理servlet、servlet 动态注册、j2ee 动态创建servlet、动态添加servlet、servlet中文乱码处理，以便于您获取更多的相关知识。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-20 16:28:10</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%96%87%e4%bb%b6/" title="文件">文件</a>, <a href="https://www.iamivan.net/tag/%e7%a4%ba%e4%be%8b/" title="示例">示例</a>, <a href="https://www.iamivan.net/tag/%e6%a0%87%e8%ae%b0/" title="标记">标记</a>, <a href="https://www.iamivan.net/tag/%e5%a4%a7%e5%b0%8f/" title="大小">大小</a>, <a href="https://www.iamivan.net/tag/%e5%9b%be%e5%83%8f/" title="图像">图像</a>, <a href="https://www.iamivan.net/tag/java/" title="java">java</a>, <a href="https://www.iamivan.net/tag/java%e7%b1%bb%e7%9a%84%e5%8a%a8%e6%80%81%e8%a3%85%e5%85%a5/" title="java类的动态装入">java类的动态装入</a>, <a href="https://www.iamivan.net/tag/jsp%c2%a0img%c2%a0%e6%b5%81/" title="jsp&nbsp;img&nbsp;流">jsp&nbsp;img&nbsp;流</a>, <a href="https://www.iamivan.net/tag/%e5%9b%be%e5%83%8f%e7%bc%96%e7%a0%81-%e6%9c%80%e4%bd%b3%e5%8c%b9%e9%85%8d%e5%9d%97/" title="图像编码 最佳匹配块">图像编码 最佳匹配块</a>, <a href="https://www.iamivan.net/tag/imagesize/" title="imagesize">imagesize</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>控制动态servlet图形处理(2)的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/qzD6aXM.html" rel="bookmark">控制动态servlet图形处理&lpar;1&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				servlet|动态|控制|图形 控制世界-或者至少控制您的图像 作为一名站点开发人员或页面作者,迎合所有这些喜好是很困难的.要手工执行该工作,必须将站点上的每个图像转换成您的网站支持的图像大小.然后,需要调整站点上每个页面中的图像标记,使每个标记都正确地反映图像的大小.不能只更改 HTML img 标记的宽(width)和高(height),而不更改图像:这会导致低带宽用户下载大的图像,并在客户机端重新调整它的大小.如果提供了八个常用的图像大小,很容易可以看到每个图像将如何需要八个缩放大小,以			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MNvOxNM.html" rel="bookmark">使用jsp&colon;include控制动态内容的方法&lowbar;JSP编程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了使用jsp:include控制动态内容的方法.分享给大家供大家参考,具体如下: 清单 1. JSP include 伪指令 &lt;![CDATA[ &lt;%@ page language=&quot;java&quot; contentType=&quot;text/html&quot; %&gt; &lt;html&gt; &lt;head&gt; &lt;title&gt;newInstance.com&lt;/title&gt; &lt;meta http-equiv=&quot;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/7b2BDQb.html" rel="bookmark">JSP 最佳实践：用 jsp&colon;include 控制动态内容</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				include|js|动态|控制 本文是 Java&quot;知情人士&quot;Brett McLaughlin 继第一篇 JSP 最佳实践文章后的后续文章,在文中,作者向您演示了如何扩展 JSP 技术中用于动态内容的包含功能.了解静态 include 伪指令和动态 jsp:include 元素之间的差异,搞清楚如何混合搭配这二者以获取最优性能.在新的 JSP 最佳实践系列的前一篇文章中,您了解了如何使用 JSP include 伪指令将诸如页眉.页脚和导航组件之类的静态内容包含到 Web 页面中.和服			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pm773qb.html" rel="bookmark">JSP最佳实践&colon; 用jsp&colon;include控制动态内容</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				简介:本文是 Java Brett McLaughlin 继第一篇 JSP 最佳实践文章后的后续文章,在文中,作者向 您演示了如何扩展 JSP 技术中用于动态内容的包含功能.了解静态 include 伪指令和动态 jsp:include 元素之间的差异,搞清楚如何混合搭配这二者以获取最优性能. 在新的 JSP 最佳实践系列的前一篇文章中,您了解了如何使用 JSP include 伪指令将诸如页眉.页 脚和导航组件之类的静态内容包含到 Web 页面中.和服务器端包含一样,JSP include 伪			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/OM9B5op.html" rel="bookmark">Jsp &amp;amp&semi;amp&semi; Servlet 会话控制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				js|servlet|控制 Jsp &amp; Servlet 会话控制 作者:guipei 前言作为J2EE的重要组成部分的jsp和servlet规范中,会话(session)处理占有非常重要的位置.目前,很多资料都非常详细的讲解了会话跟踪如何处理.但是,针对会话控制却很少有人涉及,原本在servlet规范中,servlet提供了HttpSessionContext接口处理会话控制功能,但是,在Servlet API 2.1以后,这个功能被取消了,参考原文(As of Java(tm) Servlet			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/jbEw19p.html" rel="bookmark">控制共享库的符号可见性（一） 符号可见性简介</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				什么是符号和符号可见性 符号是谈及对象文件.链接等内容时的基本术语之一.实际上,在 C/C++ 语言中,符号是很多用户定义的变量.函数名称以 及一些名称空间.类/结构/名称等的对应实体.例如,当我们定义非静态全局变量或非静态函数时,C/C++ 编译器就会在对象文 件中生成符号,这些符号对于链接器(linker)确定不同模块(对象文件.动态共享库.可执行文件)是否会共享相同的数据或 代码很有用. 尽管变量和函数都可能会在模块之间共享,但是对象文件之间的变量共享更为常见.例如,程序员可能会在 a.c			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M9EKYRM.html" rel="bookmark">servlet&plus;jsp&plus;java实现Web 应用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				用java来构建一个web应用是特别容易的事情,jsp和php很像,可以嵌套在html中.程序的结构很简单,也很清楚,本文主要记录下大概的开发过程和环境的搭建. 环境搭建 下载: eclipse  tomcat eclipse tomcat 插件 开发过程 1.建立一个Dynamic Web Project 2.创建一个欢迎页面 页面可以是jsp/html,我们选择一个jsp页面(放在WebContent内) &lt;%@ page language=&quot;java&quot; contentTyp			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bodaqvM.html" rel="bookmark">解决Linux动态库版本兼容问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				说道&quot;动态库版本兼容&quot;,很多人头脑中首先蹦出的就是&quot;Dll Hell&quot;.啊,这曾经让人头疼的难题.时至今日,这个难题已经很好地解决了. 在进一步讨论之前来思考一个问题:Linux下为什么没有让人头痛的&quot;DllHell&quot;?回答这个问题,非常easy,因为--Linux下根本没有dll! 哈哈,当然这只是个玩笑,接下来展开一下这个话题,很多有动态库的系统都会面临这个难题,但各自解决的思路却各不相同. Dll hell是指windows 上动态库新版本			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zOWjy5z.html" rel="bookmark">在Linux上将视频转换成动态gif图片</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				虽然曾经被认为是过时的艺术形式,但动态GIF图片现在复苏了.如果你还没有留意到,不少在线分享和社交网络网站都开始支持动态GIF图片,例如,Tumblr,Flickr,Google+和Facebook的部分地方.由于在消费和共享上的容易,GIF的动画已经成为主流互联网文化的一部分了. 所以,你们中的一些人会好奇怎样才能生成这样的动态GIF图片.已经有各种各样专门用来生成动态GIF图片的在线或离线工具.另一种选择是创建一副动态GIF图片时关闭现有的视频剪辑.在这个教程中,我会描述在Linux上如何将			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Vzwm4WM.html" rel="bookmark" class="title">Tomcat&plus;SQL Server2000连接池配置</a>
					<div>
						server|server2000|sql 终于解决了困扰多天的连接池的问题,写下这编文章与大家一起分享.我是在tomcat5.5.9下配置的,tomcat5.5.X和以前的版本有一些差别,所以配置上 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/dzZG6ob.html" rel="bookmark" class="title">从SQL备份文件中导入现存数据库</a>
					<div>
						SQL本身有数据导入的操作.但如果要从一个备份的文件中导入数据,则要进行另外的操作.下面以一个例子进行说明. SQL服务器上已有一个DOE数据库,并且里面有大量的数据,现准备从另外一个备份文件A1.B ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMyog4z.html" rel="bookmark" class="title">以用户为中心设计&colon;探讨产品如何满足不同类型的用户</a>
					<div>
						文章描述:以用户为中心设计是产品设计的永恒主题这一观点得到了几乎所有人的认同.既然要把用户放到最高的位置,满足用户的需求,那么设计者在了解产品之前,必须了解用户. 圣经中的上帝说,要有光,于是就有了光 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMyQ7EM.html" rel="bookmark" class="title">PHP中date函数的选项说明</a>
					<div>
						date 将服务器的时间格式化 语法描述为string date(string format,int[timestamp]);返回值的数据类型是字符串. 函数说明: 返回值的字符串按配置的格式决定.字 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/yMAZOZp.html" rel="bookmark" class="title">Flex与java交互之数据库数据读取</a>
					<div>
						前几天有网友要我写一篇关于flex与数据库交互的例子,一直由于时间紧没能写,今天晚上特地花点时间写了个例子,希望能给大家一点帮助,其实flex与数据库交互很简单的,我主要是通过java与数据库交互读取 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGjr7op.html" rel="bookmark" class="title">AutoCad修改样条曲线</a>
					<div>
						对于用&quot;spline&quot;命令创建的样条曲线对象,用户可使用&quot;splinedit&quot;命令来进行修改.该命令的调用方式为: 工具栏:&quot;Modify II(修改 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB2yrab.html" rel="bookmark" class="title">如何给QQ和MSN聊天记录加密</a>
					<div>
						QQ和MSN都是我们平时最常用到的网上聊天软件,但除了把它们用在与网友聊天之外,越来越多的公司也把联系公司业务的工作交给了它们.如此一来,就有大量的涉密信息会随着软件聊天记录而存入电脑硬盘,这多少会让 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0WBa8b.html" rel="bookmark" class="title">word页眉横线删除之后怎么添加？</a>
					<div>
						  Word 2003页眉怎么添加横线? 下面和大家说说怎样添加各式各样的页眉页脚横线. ①第一步&quot;视图&quot;--&gt;&quot;页眉和页脚&quot;,然后用光标选择页眉页脚中所 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z72OXXp.html" rel="bookmark" class="title">依然不可或缺！聊一聊网线的发展历程</a>
					<div>
						如今的我们已经步入无线时代,笔记本.平板电脑.手机等移动设备正在大面积替代传统桌面PC.伴随着这一趋势,&quot;网线&quot;似乎也开始在我们的日常工作和生活中变得越来越少见.但要强调的是,网线 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9EVrVM.html" rel="bookmark" class="title">18年前入职阿里的那些外国人，后来怎么样了？</a>
					<div>
						9月8日,在阿里巴巴庆祝18岁成人礼的时候,我们迎来了一群特殊的校友:他们是阿里最早的一批外籍员工,入职时间大都在1999年到2000年之间. 听说今年阿里巴巴要开18周年年会的消息后,校友们激动地写 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrW0LVp.html" rel="bookmark" class="title">123123-时间序列数据的可视化曲线程序设计</a>
					<div>
						问题描述 时间序列数据的可视化曲线程序设计 需要显示3天波动的曲线 3条不一样颜色 有横纵做标 可以动的 解决方案 基于控件(OCX,ActiveX)的虚拟仪器 ChengBo Software Wo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mxo6EPb.html" rel="bookmark" class="title">seo网站数据分析应重点关注的几方面</a>
					<div>
						中介交易 SEO诊断淘宝客 站长团购 云主机 技术大厅 网站数据分析是seo工作中的重要一环,比如通过流量分析才会知道网站的seo效果,想知道蜘蛛对网站的抓取情况得分析网站日志,想知道做的关键词有没有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2P0Yqp.html" rel="bookmark" class="title">sql 如何查询 空值的字段？</a>
					<div>
						select count(id) from student where ISNULL(pwd,'')='' 这样 无论pwd=''或者pwd为null都可以查到 查询非空字段,只需:ISNULL(pw ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJk8avb.html" rel="bookmark" class="title">双系统-Windows系统怎么才能与安卓x86无缝对接</a>
					<div>
						问题描述 Windows系统怎么才能与安卓x86无缝对接 我看到许多预装机有双系统的.都是win8.1与安卓,怎样才能无缝对接(不需要光盘) 解决方案 关键是你自己的计算机,android的驱动不一定 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3rBagz.html" rel="bookmark" class="title">&lbrack;译&rsqb; 回顾 ESLint 的成功</a>
					<div>
						本文讲的是[译] 回顾 ESLint 的成功, 原文地址:Reflections on ESLint's success 原文作者:Nicholas C. Zakas 译文出自:掘金翻译计划 本文永久 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zV04lkM.html" rel="bookmark" class="title">黄嘉榔：终究是慢了！互联网思维挖了传统教育的未来</a>
					<div>
						前言:互联网思维很火,教育行业也被烧身了,用不懂教育的思维做教育,是一种颠覆,用懂教育的做教育是一种自我改革.无论YY还是新东方,亦或者学大都是如此,终究逃不掉互联网思维的侵蚀.传统教育机构已经开始被 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrXRk6z.html" rel="bookmark" class="title">java签名</a>
					<div>
						问题描述 对一段xml报文做SHA1RSA签名,用XMLSignature签名结果和直接对字符串做SHA1RSA签名结果不一样,摘要值一样签名值不一样.求大神指教 解决方案					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7xX2rb.html" rel="bookmark" class="title">记录一下八款开源 Android 游戏引擎</a>
					<div>
						记录一下八款开源 Android 游戏引擎   虽然android学了点点,然后现在又没学了(我为啥这么没有恒心呢大哭).以后有时间还是要继续学android的,一定要啊!虽然现在没学android游 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVQkZDp.html" rel="bookmark" class="title">聚焦OA选型：多版本OA系统解析</a>
					<div>
						近年来,信息化愈来愈深入到我们的日常生活中,OA成了各单位管理和控制人员.资金的当红产品.很多企业在进行OA选型的时候都会问到哪家产品更适合自己,但最后仍然在几个品牌之间徘徊不定.除此之外,还需在各O ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M606QLz.html" rel="bookmark" class="title">急！关于jboss启动服务器的问题</a>
					<div>
						问题描述 这是启动jboss服务器的信息Buildfile:D:Applicationseclipsepluginsorg.eclipse.jst.server.generic.jboss_1.5.2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYXeP5b.html" rel="bookmark" class="title">6230i</a>
					<div>
						问题描述 为什么程序在别的机上都没问题,s40的也没问题,到了6230i上就显示软件无效呢 解决方案 解决方案二:空中下载还是桌面管理器安装6230i手机时间设置的是否正确解决方案三:引用1楼zhlw ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkAQK7b.html" rel="bookmark" class="title">工商局披露10种地产中介霸王条款沃居等被曝光</a>
					<div>
						市工商局市住建委通报房地产经纪行业整治情况,披露10种房地产中介霸王条款 新京报讯 (记者廖爱玲)改变房屋内部结构分割出租.利用格式条款加重消费者责任--昨日,市工商局.市住建委在&quot;北京市房 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPk7Z0M.html" rel="bookmark" class="title">Transformer架构解析</a>
					<div>
						核心观点: 服务的本质是数据的流转与变换 数据的变换依赖于数据的流转,只有流转的数据才能够被变换.基于这个理念,我们提出了Transformer架构. 基本概念定义 Transformer. 我们的每 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOnwn9p.html" rel="bookmark" class="title">限娱令挤出效应显现 视频网站比拼&OpenCurlyDoubleQuote;自制力&rdquo;</a>
					<div>
						摘要: 广电总局出台的限娱令.限广令的挤出效应正在加速显现出来. 2月6日,搜狐视频宣布与伊利.拉芳两大知名品牌达成深度战略合作;此前,优酷.土豆.爱奇艺等也传出消息,获得了广 广电总局出台的&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlmmJqp.html" rel="bookmark" class="title">Zend studio文件注释模板设置方法&lowbar;php技巧</a>
					<div>
						步骤:Window -&gt; PHP -&gt; Editor -&gt; Templates,这里可以设置(增.删.改.导入等)管理你的模板.新建文件注释.函数注释.代码块等模板的实例 新建模板, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7Qmw5M.html" rel="bookmark" class="title">js操作CheckBoxList实现全选&sol;反选&lpar;在客服端完成&rpar;&lowbar;javascript技巧</a>
					<div>
						对于CheckBoxList控件来说,一方面要实现大量数据在服务器端的绑定工作,另一方面往往要求实现全选.反选等功能.虽然可以在服务器端完成这方面的工作,但这样一个简单的工作似乎更应该在客户端完成.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZ2qgkz.html" rel="bookmark" class="title">大量用户莫名无法上网金山急推漏洞专修工具</a>
					<div>
						2月4日,金山安全客户服务中心收到大量用户的求助电话,反馈用户在使用windows7/vista系统时,经过一次更新以后重启开机速度变慢,并且上不了网.与此同时金山毒霸工程师在网络上发现大量论坛在短时 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mx20yyz.html" rel="bookmark" class="title">浅谈2011年站长不得不知的微博营销</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 新浪微博开始对外公测才一年多,其微 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk7Aoyp.html" rel="bookmark" class="title">Windows Route 路由表命令整理</a>
					<div>
						Windows Route 路由表命令 在本地 IP 路由表中显示和修改条目. 语法 route [-f] [-p] [Command [Destination] [mask Netmask] [Ga ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwyaXEM.html" rel="bookmark" class="title">花儿世界浏览器图文新手使用指南</a>
					<div>
						花儿世界是一款为儿童开发的浏览器,它可以引导小朋友们上网学知识.听儿歌.看动画片.玩http://www.aliyun.com/zixun/aggregation/28290.html&quot;&g ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 12 q. 0.038 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
